'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _sourceMapSupport2 = require('source-map-support');

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _cliSpinners = require('cli-spinners');

var _cliSpinners2 = _interopRequireDefault(_cliSpinners);

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

var _wdioInterface = require('wdio-interface');

var _wdioInterface2 = _interopRequireDefault(_wdioInterface);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)();


var clockSpinner = _cliSpinners2.default['clock'];

var WDIOCLInterface = function (_EventEmitter) {
    (0, _inherits3.default)(WDIOCLInterface, _EventEmitter);

    function WDIOCLInterface(config, specs) {
        (0, _classCallCheck3.default)(this, WDIOCLInterface);

        var _this = (0, _possibleConstructorReturn3.default)(this, (WDIOCLInterface.__proto__ || (0, _getPrototypeOf2.default)(WDIOCLInterface)).call(this));

        _this.hasAnsiSupport = _chalk2.default.supportsColor.hasBasic;
        _this.clockTimer = 0;
        _this.specs = specs;
        _this.config = config;
        _this.jobs = new _map2.default();
        _this.start = Date.now();
        _this.result = {
            finished: 0,
            passed: 0,
            failed: 0
        };
        _this.messages = {
            reporter: {}
        };

        _this.interface = new _wdioInterface2.default();
        _this.on('job:start', _this.addJob.bind(_this));
        _this.on('job:end', _this.clearJob.bind(_this));
        return _this;
    }

    /**
     * add job to interface
     */


    (0, _createClass3.default)(WDIOCLInterface, [{
        key: 'addJob',
        value: function addJob(_ref) {
            var cid = _ref.cid,
                caps = _ref.caps,
                specs = _ref.specs;

            this.jobs.set(cid, { caps, specs });
            this.updateView();
        }

        /**
         * clear job from interface
         */

    }, {
        key: 'clearJob',
        value: function clearJob(_ref2) {
            var cid = _ref2.cid,
                passed = _ref2.passed;

            this.jobs.delete(cid);
            this.result.finished++;

            if (passed) {
                this.result.passed++;
            } else {
                this.result.failed++;
            }

            this.updateView(true);
        }

        /**
         * event handler that is triggered when runner sends up events
         */

    }, {
        key: 'onMessage',
        value: function onMessage(params) {
            if (!this.messages[params.origin][params.name]) {
                this.messages[params.origin][params.name] = [];
            }
            this.messages[params.origin][params.name].push(params.content);
        }
    }, {
        key: 'updateView',
        value: function updateView(wasJobCleared) {
            var isFinished = this.jobs.size === 0;
            var pendingJobs = this.specs.length - this.jobs.size - this.result.finished;

            /**
             * check if environment supports ansi and print a limited update if not
             */
            if (!this.hasAnsiSupport && !isFinished) {
                /**
                 * only update if a job finishes
                 */
                if (!wasJobCleared) {
                    return;
                }

                var clockSpinnerSymbol = this.getClockSymbol();
                return this.interface.log(`${clockSpinnerSymbol} ` + `${this.jobs.size} running, ` + `${this.result.passed} passed, ` + `${this.result.failed} failed, ` + `${this.specs.length} total ` + `(${Math.round(this.result.finished / this.specs.length * 100)}% completed)`);
            }

            this.interface.clearAll();
            this.interface.log();

            /**
             * print reporter output
             */
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = (0, _getIterator3.default)((0, _entries2.default)(this.messages.reporter)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var _ref3 = _step.value;

                    var _ref4 = (0, _slicedToArray3.default)(_ref3, 2);

                    var reporterName = _ref4[0];
                    var messages = _ref4[1];

                    this.interface.log(_chalk2.default.bgYellow.black(`"${reporterName}" Reporter:`));
                    this.interface.log(messages.join(''));
                    this.interface.log();
                }

                /**
                 * print running jobs
                 */
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                for (var _iterator2 = (0, _getIterator3.default)(this.jobs.entries()), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var _ref5 = _step2.value;

                    var _ref6 = (0, _slicedToArray3.default)(_ref5, 2);

                    var cid = _ref6[0];
                    var job = _ref6[1];

                    var filename = job.specs.join(', ').replace(process.cwd(), '');
                    this.interface.log(_chalk2.default.bgYellow.black(' RUNNING '), cid, 'in', job.caps.browserName, '-', filename);
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }

            if (pendingJobs) {
                this.interface.log(_chalk2.default.yellow('...', pendingJobs, 'pending tests'));
            }

            /**
             * print stdout and stderr from runners
             */
            if (isFinished) {
                if (this.interface.stdoutBuffer.length) {
                    this.interface.log(_chalk2.default.bgYellow.black(`Stdout:\n`) + this.interface.stdoutBuffer.join(''));
                }
                if (this.interface.stderrBuffer.length) {
                    this.interface.log(_chalk2.default.bgRed.black(`Stderr:\n`) + this.interface.stderrBuffer.join(''));
                }
            }

            /**
             * add empty line between "pending tests" and results
             */
            if (this.jobs.size) {
                this.interface.log();
            }

            this.interface.log('Test Suites:\t', _chalk2.default.green(this.result.passed, 'passed') + ', ' + (this.result.failed ? _chalk2.default.red(this.result.failed, 'failed') + ', ' : '') + this.specs.length, 'total', `(${Math.round(this.result.finished / this.specs.length * 100)}% completed)`);

            this.updateClock();

            if (isFinished) {
                clearTimeout(this.interval);
                this.interface.log('\n');
            }
        }
    }, {
        key: 'updateClock',
        value: function updateClock() {
            var _this2 = this;

            var interval = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 100;

            var clockSpinnerSymbol = this.getClockSymbol();

            clearTimeout(this.interval);
            this.interface.clearLine();
            this.interface.write('Time:\t\t ' + clockSpinnerSymbol + ' ' + ((Date.now() - this.start) / 1000).toFixed(2) + 's');
            this.interval = setTimeout(function () {
                return _this2.updateClock(interval);
            }, interval);
        }
    }, {
        key: 'getClockSymbol',
        value: function getClockSymbol() {
            return clockSpinner.frames[this.clockTimer = ++this.clockTimer % clockSpinner.frames.length];
        }
    }]);
    return WDIOCLInterface;
}(_events2.default);

exports.default = WDIOCLInterface;
module.exports = exports['default'];