'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _sourceMapSupport2 = require('source-map-support');

var _wdioLogger = require('wdio-logger');

var _wdioLogger2 = _interopRequireDefault(_wdioLogger);

var _wdioConfig = require('wdio-config');

var _interface = require('./interface');

var _interface2 = _interopRequireDefault(_interface);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)();


var log = (0, _wdioLogger2.default)('wdio-cli:Launcher');

var Launcher = function () {
    function Launcher(configFile, argv) {
        var _context;

        (0, _classCallCheck3.default)(this, Launcher);

        this.configParser = new _wdioConfig.ConfigParser();
        this.configParser.addConfigFile(configFile);
        this.configParser.merge(argv);

        var config = this.configParser.getConfig();
        var capabilities = this.configParser.getCapabilities();
        var specs = this.configParser.getSpecs();

        this.interface = new _interface2.default(config, specs);
        config.runnerEnv.FORCE_COLOR = this.interface.hasAnsiSupport;

        var Runner = (0, _wdioConfig.initialisePlugin)(config.runner, 'runner');
        this.runner = new Runner(configFile, config);
        this.runner.on('end', this.endHandler.bind(this));
        this.runner.on('message', (_context = this.interface).onMessage.bind(_context));

        this.argv = argv;
        this.configFile = configFile;

        this.isMultiremote = !Array.isArray(capabilities);
        this.exitCode = 0;
        this.hasTriggeredExitRoutine = false;
        this.hasStartedAnyProcess = false;
        this.schedule = [];
        this.rid = [];
        this.runnerStarted = 0;
        this.runnerFailed = 0;
    }

    /**
     * run sequence
     * @return  {Promise} that only gets resolves with either an exitCode or an error
     */


    (0, _createClass3.default)(Launcher, [{
        key: 'run',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
                var _this = this;

                var config, caps, launcher, _exitCode, cid, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, capabilities, exitCode;

                return _regenerator2.default.wrap(function _callee$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                config = this.configParser.getConfig();
                                caps = this.configParser.getCapabilities();
                                launcher = (0, _utils.getLauncher)(config);
                                _context2.next = 5;
                                return this.runner.initialise();

                            case 5:
                                _context2.next = 7;
                                return config.onPrepare(config, caps);

                            case 7:
                                _context2.next = 9;
                                return (0, _utils.runServiceHook)(launcher, 'onPrepare', config, caps);

                            case 9:
                                if (!this.isMultiremote) {
                                    _context2.next = 18;
                                    break;
                                }

                                _context2.next = 12;
                                return new _promise2.default(function (resolve) {
                                    _this.resolve = resolve;
                                    _this.startInstance(_this.configParser.getSpecs(), caps, 0);
                                });

                            case 12:
                                _exitCode = _context2.sent;
                                _context2.next = 15;
                                return (0, _utils.runServiceHook)(launcher, 'onComplete', _exitCode, config, caps);

                            case 15:
                                _context2.next = 17;
                                return config.onComplete(_exitCode, config, caps);

                            case 17:
                                return _context2.abrupt('return', _exitCode);

                            case 18:

                                /**
                                 * schedule test runs
                                 */
                                cid = 0;
                                _iteratorNormalCompletion = true;
                                _didIteratorError = false;
                                _iteratorError = undefined;
                                _context2.prev = 22;

                                for (_iterator = (0, _getIterator3.default)(caps); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                                    capabilities = _step.value;

                                    this.schedule.push({
                                        cid: cid++,
                                        caps: capabilities,
                                        specs: this.configParser.getSpecs(capabilities.specs, capabilities.exclude),
                                        availableInstances: capabilities.maxInstances || config.maxInstancesPerCapability,
                                        runningInstances: 0,
                                        seleniumServer: { hostname: config.hostname, port: config.port, protocol: config.protocol }
                                    });
                                }

                                /**
                                 * catches ctrl+c event
                                 */
                                _context2.next = 30;
                                break;

                            case 26:
                                _context2.prev = 26;
                                _context2.t0 = _context2['catch'](22);
                                _didIteratorError = true;
                                _iteratorError = _context2.t0;

                            case 30:
                                _context2.prev = 30;
                                _context2.prev = 31;

                                if (!_iteratorNormalCompletion && _iterator.return) {
                                    _iterator.return();
                                }

                            case 33:
                                _context2.prev = 33;

                                if (!_didIteratorError) {
                                    _context2.next = 36;
                                    break;
                                }

                                throw _iteratorError;

                            case 36:
                                return _context2.finish(33);

                            case 37:
                                return _context2.finish(30);

                            case 38:
                                process.on('SIGINT', this.exitHandler.bind(this));

                                /**
                                 * make sure the program will not close instantly
                                 */
                                if (process.stdin.isPaused()) {
                                    process.stdin.resume();
                                }

                                _context2.next = 42;
                                return new _promise2.default(function (resolve) {
                                    _this.resolve = resolve;

                                    /**
                                     * return immediately if no spec was run
                                     */
                                    if (_this.runSpecs()) {
                                        resolve(0);
                                    }
                                });

                            case 42:
                                exitCode = _context2.sent;
                                _context2.next = 45;
                                return (0, _utils.runServiceHook)(launcher, 'onComplete', exitCode, config, caps);

                            case 45:
                                _context2.next = 47;
                                return config.onComplete(exitCode, config, caps);

                            case 47:
                                return _context2.abrupt('return', exitCode);

                            case 48:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee, this, [[22, 26, 30, 38], [31,, 33, 37]]);
            }));

            function run() {
                return _ref.apply(this, arguments);
            }

            return run;
        }()

        /**
         * run multiple single remote tests
         * @return {Boolean} true if all specs have been run and all instances have finished
         */

    }, {
        key: 'runSpecs',
        value: function runSpecs() {
            var _this2 = this;

            var config = this.configParser.getConfig();

            /**
             * stop spawning new processes when CTRL+C was triggered
             */
            if (this.hasTriggeredExitRoutine) {
                return true;
            }

            while (this.getNumberOfRunningInstances() < config.maxInstances) {
                var schedulableCaps = this.schedule
                /**
                 * bail if number of errors exceeds allowed
                 */
                .filter(function () {
                    var filter = typeof config.bail !== 'number' || config.bail < 1 || config.bail > _this2.runnerFailed;

                    /**
                     * clear number of specs when filter is false
                     */
                    if (!filter) {
                        _this2.schedule.forEach(function (t) {
                            t.specs = [];
                        });
                    }

                    return filter;
                })
                /**
                 * make sure complete number of running instances is not higher than general maxInstances number
                 */
                .filter(function () {
                    return _this2.getNumberOfRunningInstances() < config.maxInstances;
                })
                /**
                 * make sure the capability has available capacities
                 */
                .filter(function (a) {
                    return a.availableInstances > 0;
                })
                /**
                 * make sure capability has still caps to run
                 */
                .filter(function (a) {
                    return a.specs.length > 0;
                })
                /**
                 * make sure we are running caps with less running instances first
                 */
                .sort(function (a, b) {
                    return a.runningInstances > b.runningInstances;
                });

                /**
                 * continue if no capability were schedulable
                 */
                if (schedulableCaps.length === 0) {
                    break;
                }

                this.startInstance([schedulableCaps[0].specs.shift()], schedulableCaps[0].caps, schedulableCaps[0].cid, schedulableCaps[0].seleniumServer);
                schedulableCaps[0].availableInstances--;
                schedulableCaps[0].runningInstances++;
            }

            return this.getNumberOfRunningInstances() === 0 && this.getNumberOfSpecsLeft() === 0;
        }

        /**
         * gets number of all running instances
         * @return {number} number of running instances
         */

    }, {
        key: 'getNumberOfRunningInstances',
        value: function getNumberOfRunningInstances() {
            return this.schedule.map(function (a) {
                return a.runningInstances;
            }).reduce(function (a, b) {
                return a + b;
            });
        }

        /**
         * get number of total specs left to complete whole suites
         * @return {number} specs left to complete suite
         */

    }, {
        key: 'getNumberOfSpecsLeft',
        value: function getNumberOfSpecsLeft() {
            return this.schedule.map(function (a) {
                return a.specs.length;
            }).reduce(function (a, b) {
                return a + b;
            });
        }

        /**
         * Start instance in a child process.
         * @param  {Array} specs  Specs to run
         * @param  {Number} cid  Capabilities ID
         */

    }, {
        key: 'startInstance',
        value: function startInstance(specs, caps, cid, server) {
            var config = this.configParser.getConfig();
            cid = this.getRunnerId(cid);
            var processNumber = this.runnerStarted + 1;

            // process.debugPort defaults to 5858 and is set even when process
            // is not being debugged.
            var debugArgs = [];
            var debugType = void 0;
            var debugHost = '';
            var debugPort = process.debugPort;
            for (var i in process.execArgv) {
                var _debugArgs = process.execArgv[i].match('--(debug|inspect)(?:-brk)?(?:=(.*):)?');
                if (_debugArgs) {
                    var _debugArgs2 = (0, _slicedToArray3.default)(_debugArgs, 3),
                        type = _debugArgs2[1],
                        host = _debugArgs2[2];

                    if (type) {
                        debugType = type;
                    }
                    if (host) {
                        debugHost = `${host}:`;
                    }
                }
            }

            if (debugType) {
                debugArgs.push(`--${debugType}=${debugHost}${debugPort + processNumber}`);
            }

            // if you would like to add --debug-brk, use a different port, etc...
            var capExecArgs = [].concat((0, _toConsumableArray3.default)(config.execArgv || []), (0, _toConsumableArray3.default)(caps.execArgv || []));

            // The default value for child.fork execArgs is process.execArgs,
            // so continue to use this unless another value is specified in config.
            var defaultArgs = capExecArgs.length ? process.execArgv : [];

            // If an arg appears multiple times the last occurrence is used
            var execArgv = [].concat((0, _toConsumableArray3.default)(defaultArgs), debugArgs, (0, _toConsumableArray3.default)(capExecArgs));

            // prefer launcher settings in capabilities over general launcher
            this.runner.run({
                cid,
                command: 'run',
                configFile: this.configFile,
                argv: this.argv,
                caps,
                processNumber,
                specs,
                server,
                isMultiremote: this.isMultiremote,
                execArgv
            });

            this.interface.emit('job:start', { cid, caps, specs });
            this.runnerStarted++;
        }

        /**
         * generates a runner id
         * @param  {Number} cid capability id (unique identifier for a capability)
         * @return {String}     runner id (combination of cid and test id e.g. 0a, 0b, 1a, 1b ...)
         */

    }, {
        key: 'getRunnerId',
        value: function getRunnerId(cid) {
            if (!this.rid[cid]) {
                this.rid[cid] = 0;
            }
            return `${cid}-${this.rid[cid]++}`;
        }

        /**
         * Close test runner process once all child processes have exited
         * @param  {Number} cid       Capabilities ID
         * @param  {Number} exitCode  exit code of child process
         */

    }, {
        key: 'endHandler',
        value: function endHandler(_ref2) {
            var _this3 = this;

            var cid = _ref2.cid,
                exitCode = _ref2.exitCode;

            var passed = exitCode === 0;
            this.exitCode = this.exitCode || exitCode;
            this.runnerFailed += !passed ? 1 : 0;
            this.interface.emit('job:end', { cid, passed });

            // Update schedule now this process has ended
            if (!this.isMultiremote) {
                // get cid (capability id) from rid (runner id)
                cid = parseInt(cid, 10);

                this.schedule[cid].availableInstances++;
                this.schedule[cid].runningInstances--;
            }

            if (!this.isMultiremote && !this.runSpecs()) {
                return;
            }

            if (passed) {
                return process.nextTick(function () {
                    _this3.interface.updateView();
                    setTimeout(function () {
                        return _this3.resolve(_this3.exitCode);
                    }, 100);
                });
            }

            /**
             * finish with exit code 1
             */
            return process.nextTick(function () {
                _this3.interface.updateView();
                setTimeout(function () {
                    return _this3.resolve(1);
                }, 100);
            });
        }

        /**
         * Make sure all started selenium sessions get closed properly and prevent
         * having dead driver processes. To do so let the runner end its Selenium
         * session first before killing
         */

    }, {
        key: 'exitHandler',
        value: function exitHandler() {
            if (this.hasTriggeredExitRoutine || !this.hasStartedAnyProcess) {
                log.log('\nKilling process, bye!');

                // When spawned as a subprocess,
                // SIGINT will not be forwarded to childs.
                // Thus for the child to exit cleanly, we must force send SIGINT
                if (!process.stdin.isTTY) {
                    this.runner.kill();
                }

                // finish with exit code 1
                return this.resolve(1);
            }

            // When spawned as a subprocess,
            // SIGINT will not be forwarded to childs.
            // Thus for the child to exit cleanly, we must force send SIGINT
            if (!process.stdin.isTTY) {
                this.runner.kill();
            }

            log.log(`

End selenium sessions properly ...
(press ctrl+c again to hard kill the runner)
`);

            this.hasTriggeredExitRoutine = true;
        }
    }]);
    return Launcher;
}();

exports.default = Launcher;
module.exports = exports['default'];