'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _sourceMapSupport2 = require('source-map-support');

exports.default = setup;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _ejs = require('ejs');

var _ejs2 = _interopRequireDefault(_ejs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _npmInstallPackage = require('npm-install-package');

var _npmInstallPackage2 = _interopRequireDefault(_npmInstallPackage);

var _config = require('./config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _sourceMapSupport2.install)();
function setup() {
    console.log(_config.CONFIG_HELPER_INTRO); // eslint-disable-line no-console
    _inquirer2.default.prompt(_config.QUESTIONNAIRE).then(function (answers) {
        var packagesToInstall = [];
        if (answers.installRunner) {
            packagesToInstall.push(`wdio-${answers.runner}-runner`);
        }
        if (answers.installFramework) {
            packagesToInstall.push(`wdio-${answers.framework}-framework`);
        }
        if (answers.installReporter) {
            packagesToInstall = packagesToInstall.concat(answers.reporters);
        }
        if (answers.installServices) {
            packagesToInstall = packagesToInstall.concat(answers.services);
        }
        if (answers.executionMode === 'sync') {
            packagesToInstall.push('wdio-sync');
        }

        if (packagesToInstall.length > 0) {
            console.log('\nInstalling wdio packages:'); // eslint-disable-line no-console
            return (0, _npmInstallPackage2.default)(packagesToInstall, { saveDev: true }, function (err) {
                if (err) {
                    throw err;
                }

                console.log('\nPackages installed successfully, creating configuration file...'); // eslint-disable-line no-console
                renderConfigurationFile(answers);
            });
        }

        renderConfigurationFile(answers);
        process.exit(0);
    });
}

function renderConfigurationFile(answers) {
    var tpl = _fs2.default.readFileSync(_path2.default.join(__dirname, '/templates/wdio.conf.tpl.ejs'), 'utf8');
    var renderedTpl = _ejs2.default.render(tpl, { answers });
    _fs2.default.writeFileSync(_path2.default.join(process.cwd(), 'wdio.conf.js'), renderedTpl);
    console.log(_config.CONFIG_HELPER_SUCCESS_MESSAGE); // eslint-disable-line no-console
}
module.exports = exports['default'];